/* ---------------------------------------------------------- */
/*  pako_sdl_opengl_app.cpp                                   */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - SDL OpenGL application class
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_sdl_opengl_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoSDLOpenglApp::PakoSDLOpenglApp()
{
}

/**
 * fXgN^(n)
 */
PakoSDLOpenglApp::~PakoSDLOpenglApp()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/*------------------------------------------------------*/
/* protected method                                     */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- onBoot() */
/**
 * SDL pʐݒ̏ۂɍs
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSDLOpenglApp::onBoot(void)
{
  int  r;
  //! videoݒύXp
  const SDL_VideoInfo* info = NULL;
  int  flags;
  float ratio = (float)m_WindowSizeW / (float)m_WindowSizeH;

  /* --- super */
  r = PakoSimpleApp::onBoot();
  if (r != 0) {
    return(1);
  }

  /* ----- SDL OpenGL ʐݒ */
  info = SDL_GetVideoInfo();
  if (!info) {
    return(1);
  }
  SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
  SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
  SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
  SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
  SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
  /* - ʃ[hύX */
  flags = SDL_OPENGL;
  if (SDL_SetVideoMode(m_WindowSizeW,
		       m_WindowSizeH,
		       info->vfmt->BitsPerPixel,
		       flags) == 0) {
    return(1);
  }
  /* - OpenGL y */
  glShadeModel( GL_SMOOTH );
  
  glCullFace( GL_BACK );
  glFrontFace( GL_CCW );
  glEnable( GL_CULL_FACE );

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1024.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glClearColor(0, 0, 0.4, 1);
  glClear(GL_COLOR_BUFFER_BIT);
  glDepthMask(GL_TRUE);

  glViewport( 0, 0, m_WindowSizeW, m_WindowSizeH );

  gluPerspective( 60.0, ratio, 1.0, 1024.0 );

  return(0);
}


/* ----------------------------------------- */
/* --- onShutdown() */
/**
 * execute ̏IĂяo㏈\bh
 * VXe̔j
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoSDLOpenglApp::onShutdown(void)
{
  return(0);
}


/* ----------------------------------------- */
/* --- swapFrameBuffer() */
/**
 * t[̍ŌŌĂяo郁\bh
 * tickDisplay()̒ɌĂ΂AۂɃt[obt@
 * ʂɕ\铮s
 * p̃foCXɉĎ
 *
 */
void PakoSDLOpenglApp::swapFrameBuffer(void)
{
  /* --- SDL  GL ` */
  glFlush();
  SDL_GL_SwapBuffers();
}

/*------------------------------------------------------*/
/* local method                                         */
/*------------------------------------------------------*/
