/* ---------------------------------------------------------- */
/*  tcgs_cave_title.cpp                                       */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    select title
    @author   rerofumi
    @since    Nov.11.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "tcgs_cave_title.h"
#include "pako_math.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

#define WAVE_RESOLUTION  8

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
CaveTitle::CaveTitle()
{
}

CaveTitle::CaveTitle(PakoOpenglApp *parent)
{
  m_parent = parent;
}

/**
 * fXgN^(n)
 */
CaveTitle::~CaveTitle()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

void CaveTitle::setParent(PakoOpenglApp *parent)
{
  m_parent = parent;
}

int CaveTitle::initalizeGame(void)
{
  PakoSpriteItem *obj;

  m_nowPlaying = 0;
  m_select = 0;
  m_selectMove = 0;
  m_selectDone = false;

  m_dispTimer = 0.0;
  m_dispTimer2 = 0.0;
  m_dispTimer3 = 0.0;
  m_dispTimer4 = 0.0;

  /* --- XvCg */
  for(int i=0; i<64; i++) {
    obj = m_parent->getSpriteItem(1, i);
    obj->m_Visible = false;
  }

  /* --- BGM */
  SoundMusic(1);

  return(0);
}

int CaveTitle::getState(void)
{
  return(m_nowPlaying);
}



/* ----------------------------------------- */
/* --- tick() */
/**
 * t[ĂяoQ[{̃\bh
 * pŃI[o[ChĂɃQ[{̂Lq
 * 1t[̍ƂI烁\bh𔲂邱
 *
 * @return trueŒʏƒAfalseŃQ[I
 *
 */
bool CaveTitle::tick(void)
{
  PakoSpriteItem *obj;
  int  y_pos;
  int key;

  /* --- ͏ */
  key = InputJoyKeyTriger(0);
  if (((key & IN_Up) != 0) && (m_select == 1)) {
    m_select = 0;
    m_selectMove = 8;
  }
  if (((key & IN_Down) != 0) && (m_select == 0)) {
    m_select = 1;
    m_selectMove = 8;
  }
  if (((key & IN_Button1) != 0) || ((key & IN_Button1) != 0)) {
    m_selectDone = true;
    m_selectAtruct = 60;
  }

  /* --- e^C}[ */
  if (m_selectMove > 0) {
    m_selectMove -= 1;
  }
  if (m_selectAtruct > 0) {
    m_selectAtruct -= 1;
  }
  m_dispTimer += 0.007;
  if (m_dispTimer > 1.0) {
    m_dispTimer -= 1.0;
  }
  m_dispTimer2 += 0.0017;
  if (m_dispTimer2 > 1.0) {
    m_dispTimer2 -= 1.0;
  }
  m_dispTimer3 += 0.0049;
  if (m_dispTimer3 > 1.0) {
    m_dispTimer3 -= 1.0;
  }
  m_dispTimer4 += 0.0005;
  if (m_dispTimer4 > 1.0) {
    m_dispTimer4 -= 1.0;
  }

  /* --- Iɐiނ悤 */
  if ((m_selectDone == true) && (m_selectAtruct == 0)) {
    m_nowPlaying = m_select + 1;
  }


  /* --- j[IpXvCg */
  /* --- ^CgS */
  obj = m_parent->getSpriteItem(1, 0);
  obj->m_PosX = 240;
  obj->m_PosY = 80;
  obj->m_SizeW = 192;
  obj->m_SizeH = 72;
  obj->m_Blend = 1.0;
  obj->m_TexU = 0;
  obj->m_TexV = 0;
  obj->m_TexW = 192;
  obj->m_TexH = 72;
  obj->m_RollZ = 0;
  obj->m_Zoom = 1.0;
  obj->m_PosCenter = true;
  obj->m_Visible = true;
  obj->m_TextureID = 0;

  /* --- IJ[\ */
  if (m_select == 0) {
    y_pos = 180+3;
    y_pos += ((220 - 180) / 8) * m_selectMove;
  }
  else {
    y_pos = 220+3;
    y_pos -= ((220 - 180) / 8) * m_selectMove;
  }
  obj = m_parent->getSpriteItem(1, 1);
  obj->m_PosX = 240;
  obj->m_PosY = y_pos;
  obj->m_SizeW = 134;
  obj->m_SizeH = 30;
  obj->m_Blend = 0.5;
  obj->m_TexU = 0;
  obj->m_TexV = 200;
  obj->m_TexW = 134;
  obj->m_TexH = 30;
  obj->m_RollZ = 0;
  obj->m_Zoom = 1.0;
  obj->m_PosCenter = true;
  obj->m_Visible = true;
  obj->m_TextureID = 0;

  /* --- 3D version */
  obj = m_parent->getSpriteItem(1, 2);
  obj->m_PosX = 240;
  obj->m_PosY = 180;
  obj->m_SizeW = 104;
  obj->m_SizeH = 24;
  obj->m_Blend = 1.0;
  obj->m_TexU = 104;
  obj->m_TexV = 176;
  obj->m_TexW = 104;
  obj->m_TexH = 24;
  obj->m_RollZ = 0;
  obj->m_Zoom = 1.0;
  obj->m_PosCenter = true;
  obj->m_Visible = true;
  obj->m_TextureID = 0;
  
  /* --- 2D version */
  obj = m_parent->getSpriteItem(1, 3);
  obj->m_PosX = 240;
  obj->m_PosY = 220;
  obj->m_SizeW = 104;
  obj->m_SizeH = 24;
  obj->m_Blend = 1.0;
  obj->m_TexU = 0;
  obj->m_TexV = 176;
  obj->m_TexW = 104;
  obj->m_TexH = 24;
  obj->m_RollZ = 0;
  obj->m_Zoom = 1.0;
  obj->m_PosCenter = true;
  obj->m_Visible = true;
  obj->m_TextureID = 0;


  return true;
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
 * t[Ăяoʕ\\bh
 * pŃI[o[ChĂɉʕ`揈Lq
 * tick()̒ɋLqĂǂA̓t[XLbv
 * ΂Ă΂Ȃ̂ŏ肭p
 *
 * @return trueŒʏƒAfalseŕ\ُ
 *
 */
bool CaveTitle::tickDisplay(void)
{
  float upper[WAVE_RESOLUTION], lower[WAVE_RESOLUTION];
  int  i;
  float s;

  /* --- wî˂˕\ */
  for(i=0; i<WAVE_RESOLUTION; i++) {
    s = m_dispTimer + (0.07*(float)i);
    upper[i] = 0.04 * PakoMath::Sin((long)(s * 65536.0));
    s = m_dispTimer2 + (0.07*(float)i);
    upper[i] += 0.03 *PakoMath::Sin((long)(s * 65536.0));
    s = m_dispTimer3 + (0.05*(float)i);
    lower[i] = 0.1 + 0.06 *PakoMath::Sin((long)(s * 65536.0));
  }

  glDisable(GL_LIGHTING);
  glMatrixMode(GL_MODELVIEW);
  glDisable(GL_CULL_FACE);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -1.0);
  glColor4f(0.7, 0.6, 0.2, 1.0);
  /* upper */
  glBegin(GL_POLYGON);
  glVertex3f(-0.5, 0.5, 0.0);
  glVertex3f( 0.5, 0.5, 0.0);
  for(i=0; i<WAVE_RESOLUTION; i++) {
    glVertex3f(0.5-((1.0/WAVE_RESOLUTION)*i), 0.05+upper[i], 0.0);
  }
  glEnd();
  /* lower */
  glBegin(GL_POLYGON);
  glVertex3f(-0.5, -0.5, 0.0);
  glVertex3f( 0.5, -0.5, 0.0);
  for(i=0; i<WAVE_RESOLUTION; i++) {
    glVertex3f(0.5-((1.0/WAVE_RESOLUTION)*i), 0.05+upper[i]-lower[i], 0.0);
  }
  glEnd();
  /* upper shadow */
  glEnable(GL_BLEND);
  glColor4f(0.9, 0.1, 0.0, 0.01);
  glBegin(GL_POLYGON);
  glVertex3f(-0.5, 0.5, -0.1);
  glVertex3f( 0.5, 0.5, -0.1);
  for(i=0; i<WAVE_RESOLUTION; i++) {
    glVertex3f(0.5-((1.0/WAVE_RESOLUTION)*i)+0.02, 0.05+upper[i]-0.006, -0.1);
  }
  glEnd();
  glDisable(GL_BLEND);

  /* --- ŃOf̎lp */
  glTranslatef(0.0, 0.0, -0.2);
  glRotatef(360.0*m_dispTimer4, 0.0, 0.0, 1.0);
  glScalef(1.0, 1.0, 1.0);
  glBegin(GL_POLYGON);
  glColor4f(0.1, 0.05, 0.0, 1.0);
  glVertex3f(-0.5, -0.5, 0.0);
  glColor4f(0.1, 0.05, 0.0, 1.0);
  glVertex3f( 0.5, -0.5, 0.0);
  glColor4f(0.4, 0.3, 0.2, 1.0);
  glVertex3f( 0.5,  0.5, 0.0);
  glColor4f(0.4, 0.3, 0.2, 1.0);
  glVertex3f(-0.5,  0.5, 0.0);
  glEnd();

  return true;
}


/*------------------------------------------------------*/
/* private method                                       */
/*------------------------------------------------------*/
